Tankadin2_AD_Options = {
	show = true,
	display = 1,
	message = "Ardent Defender :: Death Avoided!",
	tooltip = true,
	announce = true,
	annLocal = true,
	info = {
		currRank = 0,
		maxRank = 0,
		percent = 0
	},
	session = {
		DamageADMitigated = 0,
		DamageTaken = 0,
		DeathsAverted = 0,
		percentageReduced =0
	},
	lastCombat = {
		DamageADMitigated = 0,
		DamageTaken = 0,
		DeathsAverted = 0,
		percentageReduced =0
	}
};

function Tankadin_AD_WriteData()
	AD_Data = "";
	if Tankadin2_AD_Options.display == 1 then
		if (Tankadin2_AD_Options.lastCombat.DamageTaken > 1000000) then
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round((Tankadin2_AD_Options.lastCombat.DamageTaken/1000000), 2).."m\n";
		elseif (Tankadin2_AD_Options.lastCombat.DamageTaken > 10000) then
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round((Tankadin2_AD_Options.lastCombat.DamageTaken/1000), 1).."k\n";
		else
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageTaken, 0).."\n";
		end
		AD_Data = AD_Data..TANKADIN_AD_DM..": "..Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageADMitigated, 0).."\n";
		AD_Data = AD_Data.."%: "..Tankadin2_AD_Options.lastCombat.percentageReduced.."\n";
		AD_Data = AD_Data..TANKADIN_AD_DA..": "..Tankadin2_AD_Options.lastCombat.DeathsAverted.."\n";
	elseif Tankadin2_AD_Options.display == 2 then
		if (Tankadin2_AD_Options.session.DamageTaken > 1000000) then
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round((Tankadin2_AD_Options.session.DamageTaken/1000000), 2).."m\n";
		elseif (Tankadin2_AD_Options.session.DamageTaken > 10000) then
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round((Tankadin2_AD_Options.session.DamageTaken/1000), 1).."k\n";
		else
			AD_Data = AD_Data..TANKADIN_AD_DT..": "..Tankadin_round(Tankadin2_AD_Options.session.DamageTaken, 0).."\n";
		end
		AD_Data = AD_Data..TANKADIN_AD_DM..": "..Tankadin_round(Tankadin2_AD_Options.session.DamageADMitigated, 0).."\n";
		AD_Data = AD_Data.."%: "..Tankadin2_AD_Options.session.percentageReduced.."\n";
		AD_Data = AD_Data..TANKADIN_AD_DA..": "..Tankadin2_AD_Options.session.DeathsAverted.."\n";
	end
	Tankadin_AD_String:SetText(AD_Data);
end

function Tankadin_AD_Clear()
	Tankadin2_AD_Options.session.DamageADMitigated = 0;
	Tankadin2_AD_Options.session.DamageTaken = 0;
	Tankadin2_AD_Options.session.DeathsAverted = 0;
	Tankadin2_AD_Options.session.percentageReduced = 0;
	Tankadin2_AD_Options.lastCombat.DamageADMitigated = 0;
	Tankadin2_AD_Options.lastCombat.DamageTaken = 0;
	Tankadin2_AD_Options.lastCombat.DeathsAverted = 0;
	Tankadin2_AD_Options.lastCombat.percentageReduced = 0;
	Tankadin_AD_WriteData();
end

--Grabs AD Talent Data
function TankadinRefreshADTalentInfo()
	local nameTalent, icon, tier, column, currRank, maxRank = GetTalentInfo(2,18);
    Tankadin2_AD_Options.info.curRank = currRank;
	Tankadin2_AD_Options.info.maxRank = maxRank;
	Tankadin2_AD_Options.info.percent = currRank * 10;
	--Tankadin_Message(nameTalent.." "..tier.." "..column.." "..currRank.."/"..maxRank);
end

local function Tankadin_ADMod_OnLoad()
	Tankadin_Hooks_CopyAD = Tankadin_Hooks;
	Tankadin_Hooks = Tankadin_AD_Hooks;
	Tankadin_UpdateColorHook_CopyAD = Tankadin_UpdateColorHook;
	Tankadin_UpdateColorHook = Tankadin_AD_ColorHook;
end

function Tankadin_AD_ColorHook()
	Tankadin_UpdateColorHook_CopyAD();
	
	Tankadin_ADMod_Frame:SetBackdropColor(Tankadin2_Options.Color.BG[1],Tankadin2_Options.Color.BG[2],Tankadin2_Options.Color.BG[3],Tankadin2_Options.Color.BG[4]);
	Tankadin_ADMod_Frame:SetBackdropBorderColor(Tankadin2_Options.Color.Border[1],Tankadin2_Options.Color.Border[2],Tankadin2_Options.Color.Border[3],Tankadin2_Options.Color.Border[4]);
	Tankadin_AD_String:SetTextColor(Tankadin2_Options.Color.Font[1],Tankadin2_Options.Color.Font[2],Tankadin2_Options.Color.Font[3],Tankadin2_Options.Color.Font[4]);
end

T2GADWIPE = false;

function Tankadin_AD_Hooks(self, event, ...)
	Tankadin_Hooks_CopyAD(self, event, ...);
	
	--Local Functions
	local band = bit.band;
	local floor = math.floor;
	
	--Grab Variables
	local PlayerGUID           = UnitGUID("player");
	local PlayerHP             = UnitHealth("player");
	local PlayerHP_MAX         = UnitHealthMax("player");
	local adThreshold          = floor(PlayerHP_MAX * 0.35);
	
	--[[Old Fix Removed in 3.2
	if T2PreviousPlayerHP == nil then
		T2PreviousPlayerHP = PlayerHP_MAX;
	end
	]]--
	--Assemble Combt Messge to monitor
	local Tankadin_ADCOMBAT_EVENTS = {
		SWING_DAMAGE = true,
		RANGE_DAMAGE = true,
		SPELL_DAMAGE = true,
		SPELL_PERIODIC_DAMAGE = true,
		DAMAGE_SHIELD = true,
		DAMAGE_SPLIT = true
	}
	
	if  (event == "COMBAT_LOG_EVENT_UNFILTERED" )then
	
	local timestamp, eventType, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, prefix1, prefix2, prefix3, suffix1, suffix2, suffix3, suffix4, suffix5, suffix6, suffix7, suffix8 = ...;
	
	if (eventType == "SPELL_AURA_APPLIED" and sourceGUID == PlayerGUID  and prefix1 == Tankadin_Spells.ArdentDefender[1] )then
	--7/11 05:24:15.712  SPELL_AURA_APPLIED,0x0480000000A3CAAC,"Chloe",0x511,0x0480000000A3CAAC,"Chloe",0x511,66233,"Ardent Defender",0x2,DEBUFF
	--7/11 09:14:15.873  SWING_DAMAGE,0xF130007E2B00358C,"Bone Sentinel",0x10a48,0x0480000000A3CAAC,"Chloe",0x511,379,0,1,0,0,162,nil,nil,nil
		if Tankadin2_AD_Options.ADSaveAnnounce then Tankadin_Broadcast(Tankadin2_AD_Options.ADCDMessage) end
		if Tankadin2_AD_Options.ShowADBar then Tankadin_AD_ProcTimerActivate(Tankadin2_AD_Options.DBMBar) end
	end
	
	
	--Start AD Tracking
	--OnCombatLog(event, timestamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, amount)
		if( not Tankadin_ADCOMBAT_EVENTS[eventType] or (band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) == 0)) then 
		
		else
	
	--Reassign Damage for physical attacks
			if eventType == "SWING_DAMAGE" then
				suffix1 = prefix1;
				suffix6 = suffix3;
			end
	-- Disable Tracking for Wipe Call
			if T2GADWIPE ~= true then
	--Check for AD Range
			if (PlayerHP < adThreshold) then
			--[[Pre-3.2 Code
				local OriginalDamage = floor(100 / (100 - Tankadin2_AD_Options.info.percent) * suffix1);
				Tankadin2_AD_Options.lastCombat.DamageTaken = Tankadin2_AD_Options.lastCombat.DamageTaken + OriginalDamage;
				Tankadin2_AD_Options.session.DamageTaken = Tankadin2_AD_Options.session.DamageTaken + OriginalDamage;
				Tankadin2_AD_Options.lastCombat.DamageADMitigated = Tankadin2_AD_Options.lastCombat.DamageADMitigated + (OriginalDamage - suffix1);
				Tankadin2_AD_Options.session.DamageADMitigated = Tankadin2_AD_Options.session.DamageADMitigated + (OriginalDamage - suffix1);
				if( PlayerHP <= OriginalDamage and PlayerHP ~= 0) then
					Tankadin2_AD_Options.lastCombat.DeathsAverted = Tankadin2_AD_Options.lastCombat.DeathsAverted + 1;
					Tankadin2_AD_Options.session.DeathsAverted = Tankadin2_AD_Options.session.DeathsAverted + 1;
					if (Tankadin2_AD_Options.info.curRank > 0 and Tankadin2_AD_Options.announce) then
						Tankadin_Broadcast(Tankadin2_AD_Options.message);
					end
				end
			else
				Tankadin2_AD_Options.lastCombat.DamageTaken = Tankadin2_AD_Options.lastCombat.DamageTaken + suffix1;
				Tankadin2_AD_Options.session.DamageTaken = Tankadin2_AD_Options.session.DamageTaken + suffix1;
				]]--
				if suffix6 == nil then suffix6 = 0 end
				if suffix3 == nil then suffix3 = 0 end
				Tankadin2_AD_Options.lastCombat.DamageTaken = Tankadin2_AD_Options.lastCombat.DamageTaken + suffix1;
				Tankadin2_AD_Options.session.DamageTaken = Tankadin2_AD_Options.session.DamageTaken + suffix1;
				Tankadin2_AD_Options.lastCombat.DamageADMitigated = Tankadin2_AD_Options.lastCombat.DamageADMitigated + suffix6;
				Tankadin2_AD_Options.session.DamageADMitigated = Tankadin2_AD_Options.session.DamageADMitigated + suffix6;
				if( PlayerHP <= suffix1 and PlayerHP ~= 0) then
					Tankadin2_AD_Options.lastCombat.DeathsAverted = Tankadin2_AD_Options.lastCombat.DeathsAverted + 1;
					Tankadin2_AD_Options.session.DeathsAverted = Tankadin2_AD_Options.session.DeathsAverted + 1;
					if (Tankadin2_AD_Options.info.curRank > 0 and Tankadin2_AD_Options.announce) then
						Tankadin_Broadcast(Tankadin2_AD_Options.message);
					end
				end
			else
				Tankadin2_AD_Options.lastCombat.DamageTaken = Tankadin2_AD_Options.lastCombat.DamageTaken + suffix1;
				Tankadin2_AD_Options.session.DamageTaken = Tankadin2_AD_Options.session.DamageTaken + suffix1;
			end
				
			end
		end
	--End AD Tracking
	if (Tankadin2_AD_Options.lastCombat.DamageTaken ~= 0) then
			Tankadin2_AD_Options.lastCombat.percentageReduced = Tankadin_round((Tankadin2_AD_Options.lastCombat.DamageADMitigated*100/Tankadin2_AD_Options.lastCombat.DamageTaken), 2);
		else
			Tankadin2_AD_Options.lastCombat.percentageReduced = 0;
		end
		
		if (Tankadin2_AD_Options.session.DamageTaken ~= 0) then
			Tankadin2_AD_Options.session.percentageReduced = Tankadin_round((Tankadin2_AD_Options.session.DamageADMitigated*100/Tankadin2_AD_Options.session.DamageTaken), 2);
		else
			Tankadin2_AD_Options.session.percentageReduced = 0;
		end
	--Write to String
	Tankadin_AD_WriteData();
	--T2PreviousPlayerHP = PlayerHP;
	end

	
	if (event == "CHARACTER_POINTS_CHANGED" or event == "PLAYER_TALENT_UPDATE") then
		TankadinRefreshADTalentInfo();
		Tankadin_AD_WriteData();
	end
	
	if (event == "PLAYER_REGEN_DISABLED") then
		-- Entered Combat. Clearing Variables
		Tankadin2_AD_Options.lastCombat.DamageTaken = 0;
		Tankadin2_AD_Options.lastCombat.DamageADMitigated = 0;
		Tankadin2_AD_Options.lastCombat.DeathsAverted = 0;
		TankadinRefreshADTalentInfo();
		Tankadin_AD_WriteData();
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then
		-- Left Combat, Adjust Damage Taken and Print Info if needed
		if (Tankadin2_AD_Options.lastCombat.DamageTaken ~= 0) then
			Tankadin2_AD_Options.lastCombat.percentageReduced = Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageADMitigated*100/Tankadin2_AD_Options.lastCombat.DamageTaken);
		else
			Tankadin2_AD_Options.lastCombat.percentageReduced = 0;
		end
		
		if (Tankadin2_AD_Options.session.DamageTaken ~= 0) then
			Tankadin2_AD_Options.session.percentageReduced = Tankadin_round(Tankadin2_AD_Options.session.DamageADMitigated*100/Tankadin2_AD_Options.session.DamageTaken);
		else
			Tankadin2_AD_Options.session.percentageReduced = 0;
		end
		
		AdString = TANKADIN_AD_SUM;
		if ( Tankadin2_AD_Options.lastCombat.DamageTaken ~= 0 and Tankadin2_AD_Options.annLocal) then
			DEFAULT_CHAT_FRAME:AddMessage(format(AdString, Tankadin2_AD_Options.lastCombat.DamageADMitigated, Tankadin2_AD_Options.lastCombat.DamageTaken, (Tankadin2_AD_Options.lastCombat.percentageReduced), Tankadin2_AD_Options.lastCombat.DeathsAverted));
		end
		--Reset Wipe Variable
		T2GADWIPE = false;
	end
	
	if event == "PLAYER_ENTERING_WORLD" then
		Tankadin_AD_UpdateOptions();
		Tankadin_ADMod_Frame:SetBackdropColor(Tankadin2_Options.Color.BG[1],Tankadin2_Options.Color.BG[2],Tankadin2_Options.Color.BG[3],Tankadin2_Options.Color.BG[4]);
		Tankadin_ADMod_Frame:SetBackdropBorderColor(Tankadin2_Options.Color.Border[1],Tankadin2_Options.Color.Border[2],Tankadin2_Options.Color.Border[3],Tankadin2_Options.Color.Border[4]);
		Tankadin_AD_String:SetTextColor(Tankadin2_Options.Color.Font[1],Tankadin2_Options.Color.Font[2],Tankadin2_Options.Color.Font[3],Tankadin2_Options.Color.Font[4]);
		Tankadin_AD_WriteData();
		if Tankadin2_AD_Options.show then
			Tankadin_ADMod_Frame:Show();
		else
			Tankadin_ADMod_Frame:Hide();
		end
		--Disable if not on a Paladin
		local class = select(2,UnitClass("player"))
			if (class ~= "PALADIN") then
				Tankadin_Message(TANKADIN_AD_DISABLED);
				DisableAddOn("Tankadin2_AD");
				Tankadin_ADMod_Frame:Hide();
				Tankadin_ADCOMBAT_EVENTS = "";
				TankadinRefreshADTalentInfo = "";
				Tankadin2_AD_Options.info.curRank = 0;
			end
	end
	end
	

function Tankadin_AD_UpdateOptions()
	if Tankadin2_AD_Options.channel == nil then
		Tankadin2_AD_Options.channel = "SAY";
	end
	if Tankadin2_AD_Options.ShowADBar == nil then
		Tankadin2_AD_Options.ShowADBar = true;
	end
	if Tankadin2_AD_Options.ADSaveAnnounce == nil then
		Tankadin2_AD_Options.ADSaveAnnounce = true;
	end
	if Tankadin2_AD_Options.ADCDMessage == nil then
		Tankadin2_AD_Options.ADCDMessage = "ARDENT DEFENDER :: WIPE AVERTED!";
	end
	if Tankadin2_AD_Options.DBMBar == nil then
		Tankadin2_AD_Options.DBMBar = true;
	end
end

function Tankadin_AD_OnEnter()
	if Tankadin2_AD_Options.info.curRank == nil then
		TankadinRefreshADTalentInfo();
		Tankadin_AD_WriteData();
	end
	if Tankadin2_AD_Options.tooltip and Tankadin2_AD_Options.display == 1 then
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 76, 1);
		GameTooltip:SetText(TANKADIN_AD..": "..TANKADIN_AD_LASTFIGHT);
		
		local hplimit = Tankadin_round(UnitHealthMax("player") * 0.35, 0);
		local adheal  = floor(GetCombatRatingBonus(CR_DEFENSE_SKILL) * UnitHealthMax("player") * (0.3 / 140));

	
		GameTooltip:AddDoubleLine(TANKADIN_AD..": ",Tankadin2_AD_Options.info.curRank.."/"..Tankadin2_AD_Options.info.maxRank.." = "..Tankadin2_AD_Options.info.percent.."%");
		GameTooltip:AddDoubleLine(TANKADIN_AD_DT_LONG..": ", Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageTaken, 0));
		GameTooltip:AddDoubleLine(TANKADIN_AD_DM_LONG..": ", Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageADMitigated, 0));
		GameTooltip:AddDoubleLine(TANKADIN_AD_PERCENT..": ", Tankadin2_AD_Options.lastCombat.percentageReduced.."%");
		GameTooltip:AddDoubleLine(TANKADIN_AD_DA_LONG..": ", Tankadin2_AD_Options.lastCombat.DeathsAverted);
	
		GameTooltip:AddLine(TANKADIN_AD_HP_ACTIVE.." "..hplimit.." "..TANKADIN_AD_HP_ABBR);
		GameTooltip:AddLine(format(TANKADIN_AD_HEALAMOUNT, adheal));
		GameTooltipTextLeft1:SetTextColor(1, 1, 1);
		GameTooltip:Show();
	end
	if Tankadin2_AD_Options.tooltip and Tankadin2_AD_Options.display == 2 then
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 76, 1);
		GameTooltip:SetText(TANKADIN_AD..": "..TANKADIN_AD_SESSION);
		
		local hplimit = Tankadin_round(UnitHealthMax("player") * 0.35, 0);
		local adheal  = floor(GetCombatRatingBonus(CR_DEFENSE_SKILL) * UnitHealthMax("player") * (0.3 / 140));
	
		GameTooltip:AddDoubleLine(TANKADIN_AD..": ",Tankadin2_AD_Options.info.curRank.."/"..Tankadin2_AD_Options.info.maxRank.." = "..Tankadin2_AD_Options.info.percent.."%");
		GameTooltip:AddDoubleLine(TANKADIN_AD_DT_LONG..": ", Tankadin_round(Tankadin2_AD_Options.session.DamageTaken, 0));
		GameTooltip:AddDoubleLine(TANKADIN_AD_DM_LONG..": ", Tankadin_round(Tankadin2_AD_Options.session.DamageADMitigated, 0));
		GameTooltip:AddDoubleLine(TANKADIN_AD_PERCENT..": ", Tankadin2_AD_Options.session.percentageReduced.."%");
		GameTooltip:AddDoubleLine(TANKADIN_AD_DA_LONG..": ", Tankadin2_AD_Options.session.DeathsAverted);
	
		GameTooltip:AddLine(TANKADIN_AD_HP_ACTIVE.." "..hplimit.." "..TANKADIN_AD_HP_ABBR);
		GameTooltip:AddLine(format(TANKADIN_AD_HEALAMOUNT, adheal));
		GameTooltipTextLeft1:SetTextColor(1, 1, 1);
		GameTooltip:Show();
	end
end

function Tankadin_ADEcho()
	if Tankadin2_AD_Options.display == 1 then
		
		local hplimit = Tankadin_round(UnitHealthMax("player") * 0.35, 0);
		 _ = {};
		table.insert(_, TANKADIN_AD..": "..TANKADIN_AD_LASTFIGHT);
		table.insert(_, TANKADIN_AD_DT_LONG..": "..Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageTaken, 0));
		table.insert(_, TANKADIN_AD_DM_LONG..": "..Tankadin_round(Tankadin2_AD_Options.lastCombat.DamageADMitigated, 0));
		table.insert(_, TANKADIN_AD_PERCENT..": "..Tankadin2_AD_Options.lastCombat.percentageReduced.."%");
		table.insert(_, TANKADIN_AD_DA_LONG..": "..Tankadin2_AD_Options.lastCombat.DeathsAverted);
	
		table.insert(_, TANKADIN_AD_HP_ACTIVE.." "..hplimit.." "..TANKADIN_AD_HP_ABBR);

	end
	if Tankadin2_AD_Options.display == 2 then
		
		local hplimit = Tankadin_round(UnitHealthMax("player") * 0.35, 0);
		 _ = {};
		table.insert(_, TANKADIN_AD..": "..TANKADIN_AD_SESSION);
		table.insert(_, TANKADIN_AD_DT_LONG..": "..Tankadin_round(Tankadin2_AD_Options.session.DamageTaken, 0));
		table.insert(_, TANKADIN_AD_DM_LONG..": "..Tankadin_round(Tankadin2_AD_Options.session.DamageADMitigated, 0));
		table.insert(_, TANKADIN_AD_PERCENT..": "..Tankadin2_AD_Options.session.percentageReduced.."%");
		table.insert(_, TANKADIN_AD_DA_LONG..": "..Tankadin2_AD_Options.session.DeathsAverted);
	
		table.insert(_, TANKADIN_AD_HP_ACTIVE.." "..hplimit.." "..TANKADIN_AD_HP_ABBR);

	end
	
	if strlen(Tankadin2_AD_Options.channel) < 3 then
		Tankadin_EchoStats(_, "CHANNEL", Tankadin2_AD_Options.channel);
	else
		Tankadin_EchoStats(_, Tankadin2_AD_Options.channel);
	end
end


local mainFrame = CreateFrame("Frame", "Tankadin_ADMod_Frame", UIParent);
mainFrame:SetFrameStrata("MEDIUM");
mainFrame:SetToplevel(true);
mainFrame:EnableMouse(true);
mainFrame:SetMovable(true);
mainFrame:SetClampedToScreen(true);

mainFrame:SetWidth(80);
mainFrame:SetHeight(54);
mainFrame:SetPoint("CENTER");

mainFrame:SetBackdrop( { 
  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
  insets = { left = 4, right = 4, top = 4, bottom = 4 }
});
mainFrame:SetBackdropColor(0,0,0,0.4);
mainFrame:SetBackdropBorderColor(1, 0.8, 0, 0.8);

local fontString = mainFrame:CreateFontString("Tankadin_AD_String", "OVERLAY", "SystemFont_Small");
fontString:SetText("AD Plug-in\nDATA ERROR!");
fontString:SetPoint("TOP", mainFrame, "TOP", 0, 0);

local button = CreateFrame("Button", "Tankadin_AD_ModeSwitch", mainFrame, "OptionsButtonTemplate");
button:SetText("");
button:SetHeight(8);
button:SetWidth(40);
button:SetPoint("CENTER", mainFrame, "TOP", 0, 0);
button:SetScript("OnClick", function() 
	if Tankadin2_AD_Options.display == 1 then Tankadin2_AD_Options.display = 2 
	elseif Tankadin2_AD_Options.display == 2 then Tankadin2_AD_Options.display = 1 end 
	Tankadin_AD_WriteData();
end);
button:SetScript("OnEnter", function() 
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 76, 1);
	GameTooltip:SetText(TANKADIN_AD_MODESWITCH);
	GameTooltip:Show();
end);
button:SetScript("OnLeave", function() GameTooltip:Hide() end);

local button = CreateFrame("Button", "Tankadin_AD_WipeItButton", mainFrame, "OptionsButtonTemplate");
button:SetText("");
button:SetHeight(8);
button:SetWidth(40);
button:SetPoint("CENTER", mainFrame, "BOTTOM", 0, 0);
button:SetScript("OnClick", function() 
	if InCombatLockdown() == 1 then
		T2GADWIPE = true;
		Tankadin_Message(TANKADIN_AD_WIPEENABLED);
	end;
end);
button:SetScript("OnEnter", function() 
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 76, 1);
	GameTooltip:SetText(TANKADIN_AD_WIPEITLABEL);
	GameTooltip:Show();
end);
button:SetScript("OnLeave", function() GameTooltip:Hide() end);

Tankadin_ADMod_OnLoad();
 
mainFrame:SetScript("OnMouseDown", function()
	if not Tankadin2_Options.lock and arg1 == "LeftButton" then mainFrame:StartMoving() end 
	if arg1 == "RightButton" then Tankadin_AD_Clear() end
end
);

mainFrame:SetScript("OnMouseUp", function()
	mainFrame:StopMovingOrSizing()
end
);

mainFrame:SetScript("OnHide", function()
	mainFrame:StopMovingOrSizing()
end
);

mainFrame:SetScript("OnShow", function()
	TankadinRefreshADTalentInfo();
end
);

mainFrame:SetScript("OnEnter", function() Tankadin_AD_OnEnter() end);

mainFrame:SetScript("OnLeave", function() GameTooltip:Hide() end);

--!! New AD Cooldown Bar !!--
local statusbar = CreateFrame("StatusBar", "Tankadin_AD_ProcBar", UIParent);
statusbar:SetFrameStrata("MEDIUM");
statusbar:SetToplevel(true);
statusbar:EnableMouse(true);
statusbar:SetMovable(true);
statusbar:SetClampedToScreen(true);

statusbar:SetMinMaxValues(0, 120);
statusbar:SetStatusBarTexture("Interface\\CHARACTERFRAME\\BarFill");
statusbar:SetStatusBarColor(1, 1, 0, 1);
statusbar:SetOrientation("HORIZONTAL");

statusbar:SetWidth(80);
statusbar:SetHeight(15);
statusbar:SetPoint("CENTER");

statusbar:SetBackdrop( { 
  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, 
  insets = { left = -4, right = -4, top = -4, bottom = -4 }
});
statusbar:SetBackdropColor(0,0,0,1);
statusbar:SetBackdropBorderColor(1, 1, 1, .6);

statusbar:Hide();

local fontString = statusbar:CreateFontString("Tankadin_AD_ProcBarText", "OVERLAY", "SystemFont_Small");
fontString:SetText("N/A");
fontString:SetPoint("TOP", statusbar, "RIGHT", -22, 3);

TANKADIN_ADPROCTIMER = 0;
TANKADIN_ADCONTROL = 1;

function Tankadin_AD_ProcTimerActivate(dbm)
	TANKADIN_ADPROCTIMER = GetTime();
	Tankadin_AD_ProcBar:Show();
	if dbm and IsAddOnLoaded("DBM-Core") then DBM:CreatePizzaTimer(120, UnitName("player").."-"..TANKADIN_AD, true) end;
	if dbm and not IsAddOnLoaded("DBM-Core") then Tankadin_Message(TANKADIN_AD_ADDBMERROR) end;
end

statusbar:SetScript("OnUpdate", function()
TANKADIN_ADCONTROL = TANKADIN_ADCONTROL + 1;
if TANKADIN_ADCONTROL >= 10 then
	if TANKADIN_ADPROCTIMER == 0 then return else
		local cd = Tankadin_round((120 - (GetTime()-TANKADIN_ADPROCTIMER)), 0);
		statusbar:SetValue(cd);
		if cd <= 0 then TANKADIN_ADPROCTIMER = 0; statusbar:Hide(); end
	end
TANKADIN_ADCONTROL = 1;
else end
end
);

statusbar:SetScript("OnValueChanged", function()
	Tankadin_AD_ProcBarText:SetText(TANKADIN_ADABBR.." - "..Tankadin_TimeFormat(Tankadin_AD_ProcBar:GetValue(), "m"));
end
);

statusbar:SetScript("OnMouseDown", function()
	if not Tankadin2_Options.lock and arg1 == "LeftButton" and not IsShiftKeyDown() then statusbar:StartMoving() end 
	if IsShiftKeyDown() and arg1 == "LeftButton" then Tankadin_Broadcast(TANKADIN_AD_ADMESSAGETIMER..Tankadin_AD_ProcBarText:GetText(), false) end
end
);

statusbar:SetScript("OnMouseUp", function()
	statusbar:StopMovingOrSizing()
end
);

statusbar:SetScript("OnHide", function()
	statusbar:StopMovingOrSizing()
end
);